=== share/hedgewars/Data/Maps/Mushrooms/CMakeLists.txt ===
install(FILES
	map.png
	mask.png
	map.cfg
	preview.png
	DESTINATION ${SHAREPATH}Data/Maps/Mushrooms)
