=== debian/changelog ===
hedgewars (0.9.18-1) unstable; urgency=low

  [ Gianfranco Costamagna ]
  * Added myself and unera to uploaders, with unera's permission.
  * Added Debian Games Team to Maintainer and removed from uploaders.
  * Bumped compat version to 9.
  * Added some deps and build-deps on control file.
  * Removed some check in control file (higher versions
    already in oldstable)
  * Enabled hardening flags.
  * Fixed armhf and powerpc build failure with libc 2.17
    with Felix Geyer's help. (LP: #1179850)

  [ Felix Geyer ]
  * Drop build-dependency on libghc-binary-dev and libghc-deepseq-dev as
    they are just virtual packages provided by ghc.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Fri, 03 May 2013 10:31:44 +0200

hedgewars (0.9.18-0.3) experimental; urgency=low

  * Non-maintainer upload.

  [ Felix Geyer ]
  * Add missing dependency on freeglut3. (LP: #1171825)

  [ Colin Watson ]
  * Build-depend on ghc and libghc-* rather than the transitional ghc6 and
    libghc6-*. (Closes: #705125)

  [ Gianfranco Costamagna ]
  * Updated debian/rules file, the SERVER disable string has changed.

 -- Felix Geyer <fgeyer@debian.org>  Thu, 02 May 2013 17:55:31 +0200

hedgewars (0.9.18-0.2) experimental; urgency=low

  * Non-maintainer upload
  * Added patch from upstream to fix a FTBFS with haskell 7.6

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Thu, 21 Feb 2013 17:26:19 +0100

hedgewars (0.9.18-0.1) experimental; urgency=low

  * Non-maintainer upload
  * New upstream version (Closes: #691986 LP: #1073730)
    + Built using the -3 upstream tarball hedgewars-src-0.9.18-3.tar.bz2
  * Bumped standards version to 3.9.4
  * Added some external build-dependencies

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Mon, 28 Jan 2013 15:45:14 +0100
