=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
#Helping libc >= 2.17, see launchpad bug #1179850
TYPE_FLAGS = -DFPFLAGS="-k/lib/$(DEB_HOST_MULTIARCH)/libgcc_s.so.1"

DEB_CMAKE_INSTALL_PREFIX := /usr/lib/hedgewars
DEB_CMAKE_EXTRA_FLAGS      := -DNOSERVER=0 \
	-DDATA_INSTALL_DIR=/usr/share/games $(TYPE_FLAGS)

# Leftover file in upstream tarball
DEB_CLEAN_EXCLUDE := QTfrontend/main.cpp.orig

UPSTREAM_VERSION := $(shell dpkg-parsechangelog \
	|grep ^Version|awk '{print $$2}'|sed 's/-[[:digit:]]\+$$//' \
)

clean::
	rm -fr tmp-icon stamp-icon

pre-build:: stamp-icon

stamp-icon:
	rm -fr tmp-icon
	mkdir -p tmp-icon
	for icon in `find debian/hicolor-icons -type f`; do \
		dirname=`dirname $$icon`; \
		dirname=`basename $$dirname`; \
		basename=`basename $$icon .xpm`; \
		mkdir -p tmp-icon/$$dirname/apps; \
		convert $$icon tmp-icon/$$dirname/apps/$$basename.png; \
	done

tarball:
	cd .. && \
	tar --exclude=debian \
		--exclude=.git \
		-czf hedgewars_$(UPSTREAM_VERSION).orig.tar.gz \
		hedgewars-$(UPSTREAM_VERSION)
